/*
 ****************************************************************************
 * Ldap Synchronization Connector provides tools to synchronize
 * electronic identities from a list of data sources including
 * any database with a JDBC connector, another LDAP directory,
 * flat files...
 *
 *                  ==LICENSE NOTICE==
 * 
 * Copyright (c) 2008, LSC Project 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:

 *    * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *     * Neither the name of the LSC Project nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *                  ==LICENSE NOTICE==
 *
 *               (c) 2008 - 2009 LSC Project
 *         Sebastien Bahloul <seb@lsc-project.org>
 *         Thomas Chemineau <thomas@lsc-project.org>
 *         Jonathan Clarke <jon@lsc-project.org>
 *         Remy-Christophe Schermesser <rcs@lsc-project.org>
 ****************************************************************************
 */

package org.lsc.beans;

import java.lang.reflect.InvocationTargetException;

import javax.naming.NamingException;

import org.lsc.beans.AbstractBean;
import org.lsc.beans.IBean;
import org.lsc.utils.CharacterUnacceptedException;
import org.lsc.objects.Structure;

/**
 * @author Sebastien Bahloul <seb@lsc-project.org>
 */
public class structureBean extends AbstractBean implements IBean {

    /** */
    private static final long serialVersionUID = -7380100746644869972L;

    public static structureBean getInstance(Structure st)
	    throws IllegalAccessException, InvocationTargetException,
	    CharacterUnacceptedException, NamingException {
	structureBean sb = new structureBean();
	AbstractBean.mapper(structureBean.class, sb, st);
	if (st.getDistinguishName() == null) {
	    sb.generateDn();
	} else {
	    sb.setDistinguishName(st.getDistinguishName());
	}
	return sb;
    }

    // /**
    // * Ou mapping in order to generate the "description" attribute !
    // * @param st original object
    // * @param destBean object to be completed
    // * @param value the corresponding value
    // * @throws NamingException sometimes ... but not in this method !
    // * @throws CharacterUnacceptedException
    // */
    // public static void mapOu(Structure st, IBean destBean, List values)
        // throws NamingException, CharacterUnacceptedException {
    // if(values != null && values.size() > 0) {
    // String value = (String) values.iterator().next();
    // if(value != null && value.trim().length() != 0) {
    // mapString(destBean, "ou", Filters.filterString(value));
    // mapString(destBean, "description", Filters.filterString(value));
    // }
    // }
    // }

    public void generateDn() throws NamingException {
	throw new RuntimeException(
		"Unavailable generateDn method in this object !");
    }
}
